/*
 *  ******************************************************************************
 *  *
 *  *
 *  * This program and the accompanying materials are made available under the
 *  * terms of the Apache License, Version 2.0 which is available at
 *  * https://www.apache.org/licenses/LICENSE-2.0.
 *  *
 *  *  See the NOTICE file distributed with this work for additional
 *  *  information regarding copyright ownership.
 *  * Unless required by applicable law or agreed to in writing, software
 *  * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 *  * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 *  * License for the specific language governing permissions and limitations
 *  * under the License.
 *  *
 *  * SPDX-License-Identifier: Apache-2.0
 *  *****************************************************************************
 */

package org.deeplearning4j.nn.layers.feedforward.dense;

import org.deeplearning4j.nn.conf.layers.LayerConfiguration;
import org.deeplearning4j.nn.layers.BaseLayer;
import org.nd4j.linalg.api.buffer.DataType;
import org.nd4j.linalg.api.ndarray.INDArray;
import org.deeplearning4j.nn.workspace.LayerWorkspaceMgr;

/**
 * @author Adam Gibson
 */
public class DenseLayer extends BaseLayer<org.deeplearning4j.nn.conf.layers.DenseLayer> {

  public DenseLayer(LayerConfiguration conf, DataType dataType) {
    super(conf, dataType);
  }

  @Override
  public void fit(INDArray input, LayerWorkspaceMgr workspaceMgr) {
    throw new UnsupportedOperationException("Not supported");
  }

  @Override
  public boolean isPretrainLayer() {
    return false;
  }

  @Override
  public boolean hasBias() {
    return getTypedLayerConfiguration().hasBias();
  }

  @Override
  public boolean hasLayerNorm() {
    return getTypedLayerConfiguration().hasLayerNorm();
  }

    public boolean isInputModificationAllowed() {
    return true;
    }
}
